PROGRAM HUT2EDIT;       { Village Hut Player Database Editor Source Code }

USES CRT, DOS, GoldWin, GoldFast, GoldRead, GoldMisc, LordLock, Chasware;

	 {$I HutVars.INC}        {Officially released IGM v2.20 on Aug. 14, 2007.}

	  {07/22/07: Program has no untested code in it.}
	  { ===================================================== }

CONST Version: STRING = 'v1.00';
			{07/06/07: Changed to v0.97 beta}
			{ 07/12/07: Changed to v1.00. non-beta}

		(*  Compile_Date: STRING = 'August 13, 2007.';  *)  {Disabled 08/12/07}

      Release_Date: STRING = 'August 14th, 2007.';  {added 08/12/07}

      CfgName  = 'HUT2EDIT.CFG';

      HutPlayer_FN = 'HUTPLAY.DAT';

      RealName   = '1';   LordName    = '2';   PlayNum    = '3';
      Visits     = '4';   HitPts      = '5';   HitMax     = '6';
      Str_Pts    = '7';   Defense     = '8';   CharmPts   = '9';
      FFights    = '0';   PFights     = 'A';   Jewels     = 'B';
      Adoptions  = 'C';   Skill_Pts   = 'D';   Gold_Count = 'E';
      Gold_Trans = 'F';   Gold        = 'G';   Wisdom     = 'H';

		HasTools   = 'I';   TurnsLeft   = 'J';   {02/17/06: HasTools, TurnsLeft}
		Wish_Count = 'K';   MineClosed  = 'L';   {03/02/06: Wish_Count, MineClosed}

		{ 02/10/06: Dropped use of LAYS and SKILL_USES constants. }
		{ IGM is not updating either of them at current time.     }

		{ 02/10/06: 06:09 pm: Re-ordered constants into new layout. }
		{ ------------------------------------------------------- }

		{ Q - Quit/Save Changes.   X - Search for Player. }
		{ * - New Day for Player                          }

		TwoBillion: LongInt = 2000000000;
		{ ------------------------------------------------ }

		{ Visits: No limit put into use yet. }

VAR TSearch: Village_Player;   { for player searches }

	 Editor_FN : STRING;      { File Vars for HUTPLAY.DAT access }
			  {06/04/07: Changed IGM_Path to Utility_Path.}
			  {08/12/07: Changed Utility_Path to Editor_FN. }

	 TVEdit:  Village_Player;
	 Editor_File:  FILE OF Village_Player;

	 IGMDir      : STRING[80];
	 RecordNum   : BYTE;          {used by READ_VISITORS_FILE}

	 DebugVar: BOOLEAN;  {Added 07/22/07}

	 { TempNum, Used, Found: Accessed from HutVars.inc.   Used }
		{ in record Seek process.  }
	 { ================================================================================== }


	 {12/01/06: renamed ReadConfig to Read_Config.}
	 {12/01/06: Renamed F var to Config_File.}
	 {12/01/06: Changed IGMLoc from STRING[80] to STRING.}
PROCEDURE READ_CONFIG;    {VERIFIED 09/28/05}
VAR  Config_File : TEXT;

  PROCEDURE MakeConfig;
      VAR IGMLoc: STRING;
  BEGIN
    IGMLoc:= PromptStr(0,0,60,'Enter directory path to Village Hut IGM',' Installation ','',FALSE);

    Addtext(AddBack(IGMLoc),CfgName,TRUE);
  END;  { MakeConfig ---------------------------------------- }

BEGIN
  IF NOT Exist(CfgName) THEN MakeConfig;

  ASSIGN(Config_File,CfgName);
  RESET(Config_File);
  Readln(Config_File,IGMDir);
  CLOSE(Config_File);

  IGMDir:= S2U(IGMDir);

  { 07/16/05: When run from compiler, verified that value of IGMDir is known at this point. }
END;       { READ_CONFIG ------------------------------------ }


PROCEDURE READ_VISITORS_FILE;    { Reads the IGM's HUTPLAY.DAT file. }
BEGIN
  Editor_FN:= IGMDir+HutPlayer_FN;

  ASSIGN(Editor_File,Editor_FN);
  Lockfile(Editor_FN);
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  READ(Editor_File,TVEdit);

  UnLockFile(Editor_FN);
  CLOSE(Editor_File);
END;     { ---------------------------------------------------- }


PROCEDURE WRITE_VISITORS_FILE; { Writes IGM's HUTPLAY.DAT file }
BEGIN
  Editor_FN:= IGMDir+HutPlayer_FN;

  ASSIGN(Editor_File,Editor_FN);
  LOCKFILE(Editor_FN);
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  WRITE(Editor_File,TVEdit);

  UNLOCKFILE(Editor_FN);
  CLOSE(Editor_File);
END;     { WRITE_VISITORS_FILE   ------------------------------ }


PROCEDURE Search(Num:Integer);
      { Reads HUTPLAY.DAT. Does search on player record number }
BEGIN
  Editor_FN:= IGMDir+HutPlayer_FN;

  ASSIGN(Editor_File,Editor_FN);
  Lockfile(Editor_FN);
  RESET(Editor_File);

  SEEK(Editor_File,Num);
  READ(Editor_File,TSearch);

  UnLockFile(Editor_FN);
  CLOSE(Editor_File);
END;     { Search  --------------------------------------------- }


FUNCTION Get(b:CHAR):STRING;
BEGIN
  CASE UpCase(b) OF
	  RealName : Get:='`!'+TVEdit.RealName;

	  LordName : Get:='`$'+TVEdit.LordName;

	  PlayNum  : Get:='`@'+N2S(TVEdit.PlayNum);   {BYTE Var used}

	  Visits   : IF TVEdit.Visits = 0      {BYTE Var used}
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+N2S(TVEdit.Visits);

	  HitPts   : IF TVEdit.HitPoints = 0
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.HitPoints);  {06/15/06: changed to COMMA.}

	  HitMax   : IF TVEdit.HitMax = 0
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.HitMax);

	  Str_Pts  : IF TVEdit.Strength = 0
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.Strength);

	  Defense  : IF TVEdit.Defense = 0
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.Defense);

	  CharmPts : IF TVEdit.Charm = 0
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.Charm);

	  FFights  : IF TVEdit.Forest = 0        {BYTE Var used}
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.Forest);       {06/15/06: changed to COMMA.}

	  PFights  : IF TVEdit.Human = 0          {BYTE Var used}
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+N2S(TVEdit.Human);

		 { 03/02/06: Moved Turns_Left/Wishes VAR entries to here. }
	  TurnsLeft : IF TVEdit.Turns_Left = 0    {Added 02/17/06}
						  THEN  Get:= '`0None'                  {03/03/06: Show in Lt. Green}
						  ELSE  Get:= '`$'+N2S(TVEdit.Turns_Left);

	  Wish_Count : IF TVEdit.Wishes = 0       {Added 03/02/06}
						  THEN  Get:= '`#None'
						  ELSE  Get:= '`$'+N2S(TVEdit.Wishes);

	  Jewels   : IF TVEdit.Gems = 0
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+COMMA(TVEdit.Gems);

	  Adoptions: IF TVEdit.Adoptions = 0  {BYTE var used}
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+N2S(TVEdit.Adoptions);

	  Skill_Pts: IF TVEdit.Skill_Pts = 0  {BYTE Var used}
						THEN  Get:= '`#None'
						ELSE  Get:= '`$'+N2S(TVEdit.Skill_Pts);

	  Gold_Count: IF TVEdit.Gold_TCount = 0    {BYTE Var used}
						 THEN  Get:= '`#None'
						 ELSE  Get:= '`$'+N2S(TVEdit.Gold_TCount);

	  Gold_Trans: IF TVEdit.Gold_Transfers = 0
						 THEN  Get:= '`#None'
						 ELSE  Get:= '`$'+COMMA(TVEdit.Gold_Transfers);

	  Gold      : IF TVEdit.Gold = 0
						 THEN  Get:= '`#None'
						 ELSE  Get:= '`$'+COMMA(TVEdit.Gold);

	  Wisdom    : IF TVEdit.Wisdom = 0    {Added 08/19/05: VERIFIED}
						 THEN  Get:= '`#None'
						 ELSE  Get:= '`$'+COMMA(TVEdit.Wisdom);
	  { ====================================================================== }

	  HasTools  : IF TVEdit.Has_Tools           {Added 02/17/06}
						 THEN Get:= '`@Yes! '  {12/07/06: Changed to Red}
						 ELSE Get:= '`0No!';  {06/15/06: changed to No! from Nope!}

	  MineClosed: IF TVEdit.Mine_Closed         {added 03/02/06}
						 THEN Get:= '`@Yes! '   {12/07/06: Changed to Red}
						 ELSE Get:= '`0No!';    {06/15/06: changed to No! from Nope!}
  END;

  { 02/10/06: Deleted statements for LAYS and SKILL_USES.  Not used by IGM now. }

  CursorOff;   {06/25/06: needed to fix bug found by Dennis Collins.}
    { When program's user would change a setting in a dialog box, when }
    { they returned to the main screen, the cursor would be back on the }
    { screen, so this keeps the cursor deactivated while the editor runs. }
END;     { GET Func. ----------------------------------------------------- }



{ 1 }PROCEDURE Do_RealName;        {VERIFIED 02/10/06}
BEGIN
  TVEdit.RealName:=
  PromptStr(0,0,50,'Enter REAL name for player',' Player Real Name Change ',TVEdit.RealName,FALSE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,4,Replicate(50,' '));  { Write data on position 24, Line #4. }
  CWriteXY(23,4,Get(RealName));
END;


{ 2 }PROCEDURE Do_LordName;           {VERIFIED 02/10/06}
BEGIN
  TVEdit.LordName:=
  PromptStr(0,0,20,'Enter LORD Name for player',' Player Lord Name Change ',TVEdit.LordName,FALSE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,5,Replicate(20,' '));
  CWriteXY(23,5,Get(LordName));
END;


	 { In normal usage, don't allow users to change LORD Player Numbers. }
    { 07/22/07: Renamed Do_PlayNum to DO_PLAYER_NUMBER.}

{ 3 }PROCEDURE DO_PLAYER_NUMBER;             {VERIFIED 02/10/06}
BEGIN
  TVEdit.PlayNum:=
      PromptNum(0,0,'Enter player''s LORD Player # (0-160)?',' LORD Player Number Change ',
         TVEdit.PlayNum,0,170,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXy(52,5,Replicate(5,' '));    { Allow room for 3 digits, and 2 blank spaces. 07/13/05}
  CWriteXy(52,5,Get(PlayNum));
END;


{ 4 }PROCEDURE Do_Visits;            {VERIFIED 02/10/06}  {revised 06/29/06}
BEGIN
  TVEdit.Visits:=
  PromptNum(0,0,'Enter Visits Today (0-10)?',' Visits Today Change',TVEdit.Visits,0,10,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,6,Replicate(5,' '));
  CWriteXY(23,6,Get(Visits));
END;


{ 5 }PROCEDURE Do_HitPoints;               {VERIFIED 02/10/06}
BEGIN
  TVEdit.HitPoints:=
  PromptNum(0,0,'Enter # of HitPoints (0-32000)?',' HitPoints Change ',TVEdit.HitPoints,0,32000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(59,6,Replicate(4,' '));
  CWriteXY(59,6,Get(HitPts));
END;


{ 6 }PROCEDURE Do_HitMax;                 {VERIFIED 02/10/06}
BEGIN
  TVEdit.HitMax:=
  PromptNum(0,0,'Enter Max Hit-Points (0-32000)?',' Max Hit-Points Change ',TVEdit.HitMax,0,32000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,7,Replicate(6,' '));
  CWriteXY(23,7,Get(HitMax));
END;


{ 7 }PROCEDURE DO_Strength;                 {VERIFIED 02/10/06}
BEGIN
  TVEdit.Strength:=
  PromptNum(0,0,'Enter Strength Points (0-32000)?',' Strength Points Change ',TVEdit.Strength,0,32000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(59,7,Replicate(6,' '));
  CWriteXY(59,7,Get(Str_Pts));
END;


{ 8 }PROCEDURE DO_Defense;                 {VERIFIED 02/10/06}
BEGIN
  TVEdit.Defense:=
  PromptNum(0,0,'Enter Defense Points (0-32000)?',' Defense Points Change ',TVEdit.Defense,0,32000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,8,Replicate(6,' '));
  CWriteXY(23,8,Get(Defense));
END;


{ 9 }PROCEDURE DO_Charm;               {VERIFIED 02/10/06}
BEGIN
  TVEdit.Charm:=
  PromptNum(0,0,'Enter Charm Points (0-32000)?',' Charm Points Change ',TVEdit.Charm,0,32000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(59,8,Replicate(6,' '));
  CWriteXY(59,8,Get(CharmPts));
END;


{ 0 }PROCEDURE Do_Forest;               {VERIFIED 02/10/06}    {revised 06/29/06}
BEGIN                         {06/29/06: use edit range of 0 to 250, instead of 0-100.}
  TVEdit.Forest:=
  PromptNum(0,0,'Enter Forest Fights (0-250)?',' Forest Fights Change ',TVEdit.Forest,0,250,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,9,Replicate(4,' '));
  CWriteXY(23,9,Get(FFights));
END;


{ A }PROCEDURE Do_Human;               {VERIFIED 02/10/06}          {revised 06/29/06}
BEGIN                                  {06/29/06: changed edit range to 0-50 from 0-25.}
  TVEdit.Human:=
  PromptNum(0,0,'Enter Human Fights (0-50)?',' Human Fights Change ',TVEdit.Human,0,50,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(59,9,Replicate(4,' '));
  CWriteXY(59,9,Get(PFights));
END;


{ B }PROCEDURE DO_Gems;                 {VERIFIED 02/10/06}
BEGIN
  TVEdit.Gems:=
  PromptNum(0,0,'Enter # of Gems Found/Lost (-200-200)?',' Gems Change ',TVEdit.Gems,-200,200,TRUE);
								 {03/03/07: Changed to -200 to 200 edit range.}

  WRITE_VISITORS_FILE;
  CWriteXY(23,10,Replicate(6,' '));
  CWriteXY(23,10,Get(Jewels));
END;


{ C }PROCEDURE Do_Adoptions;               {VERIFIED 02/10/06}
BEGIN          {02/22/07: Changed to use 0-20 range. was using 0-10 incorrectly.}
  TVEdit.Adoptions:=
  PromptNum(0,0,'Enter Kids Adopted Today (0-20)?',' Adoptions Change ',TVEdit.Adoptions,0,20,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(59,10,Replicate(6,' '));
  CWriteXY(59,10,Get(Adoptions));
END;


{ 02/10/06: Deleted DO_LAYS proc.  LAYS VAR is not used by IGM now. }

{ D }PROCEDURE Do_Skill_Points;                 {VERIFIED 02/10/06}
BEGIN
  TVEdit.Skill_Pts:=
  PromptNum(0,0,'Enter Skill Points (0-5)?',' Skill Points Change',TVEdit.Skill_Pts,0,5,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(23,11,Replicate(5,' '));
  CWriteXY(23,11,Get(Skill_Pts));
END;


  { 02/10/06: Deleted DO_SKILL_USES procedure.  Skill_Uses VAR is not used by IGM now. }

{ E }PROCEDURE Do_Gold_Count;        {VERIFIED 02/10/06}
BEGIN
  TVEdit.Gold_TCount:=
  PromptNum(0,0,'Enter # of Gold Transfers Today (0-50)?',' Gold Transfers Count Change',TVEdit.Gold_TCount,0,50,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(59,11,Replicate(5,' '));      {Must be Position 59.}
  CWriteXY(59,11,Get(Gold_Count));
END;


{ F }PROCEDURE DO_Gold_Transfers;    {VERIFIED 02/10/06}
BEGIN
  TVEdit.Gold_Transfers:=
	 PromptNum(0,0,'Gold Transfers Amt (0-500 Million)?',' Gold Transfers Amt Change',TVEdit.Gold_Transfers,0,500000000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(27,12,Replicate(14,' '));     {Use limit of 500 Million -1st draft}
  CWriteXY(27,12,Get(Gold_Trans));       { 03/03/06: Write data at position 27 for Gold Transfers Amt}
END;


			{ 03/02/06: Renamed Do_Gold to Do_Gold_Coins. }
{ G }PROCEDURE DO_GOLD_COINS;      {VERIFIED 02/10/06}
BEGIN
  TVEdit.Gold:=
  PromptNum(0,0,'Enter Gold Coins Found (0-100 Million)?',' Gold Coins Change', TVEdit.Gold,0,100000000,TRUE);

  WRITE_VISITORS_FILE;                   {Use limit of 100 Million -1st draft}
  CWriteXY(27,13,Replicate(14,' '));     { 03/03/06: Write data at position 27 for Gold coins found}
  CWriteXY(27,13,Get(Gold));
END;


{ H }PROCEDURE Do_Wisdom;               {VERIFIED 02/10/06}
BEGIN
  TVEdit.Wisdom:=
  PromptNum(0,0,'Enter Exp Points Gain (0-500 Million)?',' Wisdom Points Change', TVEdit.Wisdom,0,500000000,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(27,14,Replicate(14,' '));     {Use limit of 500 Million -1st draft}
  CWriteXY(27,14,Get(Wisdom));           { 03/03/06: Write data at position 27 for Wisdom Pts}
END;


{ I }PROCEDURE DO_Has_Tools;           {Added 02/17/06: verified}
BEGIN
  IF TVEdit.Has_Tools THEN TVEdit.Has_Tools:= FALSE
	 ELSE IF NOT TVEdit.Has_Tools THEN TVEdit.Has_Tools:= TRUE;

  WRITE_VISITORS_FILE;
  CWriteXY(62,12,Replicate(6,' '));
  CWriteXY(62,12,Get(HasTools));          {Use column 62, Line #12, with Gold Transfers Counter}
END;


{ J }PROCEDURE Do_Turns_Left;          {Added 02/17/06: verified}
BEGIN
  TVEdit.Turns_Left:=
  PromptNum(0,0,'Enter # of Mine Turns Left (0-50)?',' Mine Turns Left Change', TVEdit.Turns_Left,0,50,TRUE);
		  {01/31/07: revised to use max of 50, instead of 250.}

  WRITE_VISITORS_FILE;
  CWriteXY(62,13,Replicate(7,' '));
  CWriteXY(62,13,Get(TurnsLeft));       {Use column 62, Line #13, with Gold Transfers amount}
END;


{ K }PROCEDURE DO_Mine_Closed;           {Added 03/02/06: verified 03/03/06}
BEGIN
  IF TVEdit.Mine_Closed THEN TVEdit.Mine_Closed:= FALSE
	 ELSE IF NOT TVEdit.Mine_Closed THEN TVEdit.Mine_Closed:= TRUE;

  WRITE_VISITORS_FILE;
  CWriteXY(62,14,Replicate(6,' '));
  CWriteXY(62,14,Get(MineClosed));          {Use column 62, Line #14}
END;


{ L }PROCEDURE Do_Wishes;          {Added 03/02/06: verified 03/03/06}
BEGIN
  TVEdit.Wishes:=
	 PromptNum(0,0,'# of Wishes Made Today (0-10)?',' Wishes Made Today Change', TVEdit.Wishes,0,10,TRUE);

  WRITE_VISITORS_FILE;
  CWriteXY(27,15,Replicate(7,' '));
  CWriteXY(27,15,Get(Wish_Count));       { 03/03/06: Use column 27, Line #15}
END;


{ No point in having Delete Player in this IGM. DeletePlayer process was removed. }

{ note: To use Y, N responses via keyboard, one has to use
  the ALT key. Or simply use the mouse to click on the option wanted. }


{ * }PROCEDURE Do_NewDay;        {VERIFIED 02/10/06}
BEGIN
  CWGotoXY(5,24);
  CWriteLn('  `0Running `!"Reset Player''s Stats" `0process. 3-second delay.');

  DELAY(3000);

  IF (TVEdit.PlayNum > 160) THEN
    BEGIN
      TVEdit.PlayNum:= 160;
      PromptOK('Advisory:',' Resetting LORD Player # field to 160.');
    END;

		{ --------------------------------------------------- }
  IF TVEdit.Visits > 0 THEN
	 BEGIN
		TVEdit.Visits:= 0;
		PromptOK('Advisory:',' Resetting the Visits Today field to Zero.');
	 END;

		{ --------------------------------------------------- }
  IF TVEdit.Gold_TCount > 0 THEN
	 BEGIN
		TVEdit.Gold_TCount:= 0;
		PromptOK('Advisory:',' Resetting the Gold Transfers Counter field to Zero.');
	 END;

  { --------------------------------------------------- }
  IF TVEdit.Skill_Pts > 0 THEN
	 BEGIN
		TVEdit.Skill_Pts:= 0;
		PromptOK('Advisory:',' Resetting the Skill Points field to Zero.');
	 END;

  { 02/10/06: Deleted IF code blocks for LAYS and SKILL_USES.  Not used by IGM now. }


  { --------------------------------------------------- }
  IF TVEdit.Forest > 0 THEN
	 BEGIN
		TVEdit.Forest:= 0;
		PromptOK('Advisory:',' Resetting the Forest Fights field to Zero.');
	 END;

  { --------------------------------------------------- }
  IF TVEdit.Human > 0 THEN
	 BEGIN
		TVEdit.Human:= 0;
		PromptOK('Advisory:',' Resetting the Human Fights field to Zero.');
	 END;

  { --------------------------------------------------- }
  IF TVEdit.HitPoints < 0 THEN
	 BEGIN
		TVEdit.HitPoints:= 0;
		PromptOK('Advisory:',' Reset negative Hit-Points field to Zero.');
	 END;

  IF TVEdit.HitPoints > 0 THEN
	 BEGIN
		TVEdit.HitPoints:= 0;
		PromptOK('Advisory:',' Resetting the Hit-Points field to Zero.');
	 END;

  { --------------------------------------------------- }
  IF TVEdit.HitMax < 0 THEN
	 BEGIN
		TVEdit.HitMax:= 0;
		PromptOK('Advisory:',' Reset negative Max HitPoints field to Zero.');
	 END;

  IF TVEdit.HitMax > 0 THEN
    BEGIN
      TVEdit.HitMax:= 0;
		PromptOK('Advisory:',' Resetting the Max HitPoints field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Strength < 0 THEN
    BEGIN
		TVEdit.Strength:= 0;
		PromptOK('Advisory:',' Reset negative Strength Points field to Zero.');
    END;

  IF TVEdit.Strength > 0 THEN
    BEGIN
		TVEdit.Strength:= 0;
		PromptOK('Advisory:',' Resetting the Strength Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Defense < 0 THEN
    BEGIN
      TVEdit.Defense:= 0;
		PromptOK('Advisory:',' Reset negative Defense Points field to Zero.');
    END;

  IF TVEdit.Defense > 0 THEN
    BEGIN
      TVEdit.Defense:= 0;
      PromptOK('Advisory:',' Resetting the Defense Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Charm < 0 THEN
    BEGIN
		TVEdit.Charm:= 0;
		PromptOK('Advisory:',' Reset negative Charm Points field to Zero.');
    END;

  IF TVEdit.Charm > 0 THEN
    BEGIN
		TVEdit.Charm:= 0;
		PromptOK('Advisory:',' Resetting the Charm Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Gems < 0 THEN
    BEGIN
		TVEdit.Gems:= 0;
		PromptOK('Advisory:',' Reset negative Gems Found field to Zero.');
    END;

  IF TVEdit.Gems > 0 THEN
    BEGIN
		TVEdit.Gems:= 0;
		PromptOK('Advisory:',' Resetting the Gems Found field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Adoptions < 0 THEN
	 BEGIN
      TVEdit.Adoptions:= 0;
		PromptOK('Advisory:',' Reset negative Kids Adopted field to Zero.');
    END;

  IF TVEdit.Adoptions > 0 THEN
    BEGIN
      TVEdit.Adoptions:= 0;
		PromptOK('Advisory:',' Resetting the Kids Adopted field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Gold_Transfers < 0 THEN
    BEGIN
      TVEdit.Gold_Transfers:= 0;
		PromptOK('Advisory:',' Reset negative Gold Transfers Amount field to Zero.');
    END;

  IF TVEdit.Gold_Transfers > 0 THEN
    BEGIN
      TVEdit.Gold_Transfers:= 0;
		PromptOK('Advisory:',' Resetting the Gold Transfers Amount field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Gold < 0 THEN
    BEGIN
      TVEdit.Gold:= 0;
		PromptOK('Advisory:',' Reset negative Gold Coins Found field to Zero.');
    END;

  IF TVEdit.Gold > 0 THEN
	 BEGIN
      TVEdit.Gold:= 0;
		PromptOK('Advisory:',' Resetting the Gold Coins Found field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TVEdit.Wisdom < 0 THEN
    BEGIN
      TVEdit.Wisdom:= 0;
      PromptOK('Advisory:',' Reset negative Wisdom Points field to Zero.');
    END;

  IF TVEdit.Wisdom > 0 THEN
	 BEGIN
      TVEdit.Wisdom:= 0;
		PromptOK('Advisory:',' Resetting the Wisdom Points field to Zero.');
	 END;

  IF TVEdit.Has_Tools THEN TVEdit.Has_Tools:= FALSE;   {Added 02/17/06}

  IF TVEdit.Turns_Left > 0 THEN      {Added 02/17/06}
    BEGIN
      TVEdit.Turns_Left:= 0;
      PromptOK('Advisory:',' Resetting the Mine Turns Left field to Zero.');
    END;

  IF TVEdit.Mine_Closed THEN TVEdit.Mine_Closed:= FALSE;   {Added 03/02/06}

  IF TVEdit.Wishes > 0 THEN      {Added 03/02/06}
    BEGIN
      TVEdit.Wishes:= 0;
      PromptOK('Advisory:',' Resetting the Wishes Made Today field to Zero.');
    END;

END;     { Do_NewDay  ================================ }


FUNCTION  MaxPlayers:Word; { Gets the number of customer records }
BEGIN                      {VERIFIED 02/10/06}
  MaxPlayers:=1;

  Editor_FN:= IGMDir+HutPlayer_FN;

  IF NOT Exist(Editor_FN) THEN Exit;

  ASSIGN(Editor_File,Editor_FN);
  LOCKFILE(Editor_FN);
  RESET(Editor_File);

  MaxPlayers:= FileSize(Editor_File);

  UNLOCKFILE(Editor_FN);
  CLOSE(Editor_File);
END;     { MaxPlayers  --------------------------------------------- }


FUNCTION GetRecordNum:STRING;      {VERIFIED 02/10/06}
BEGIN
  GetRecordNum:='`$'+N2S(RecordNum + 1)+' `%of `@'+N2S(MaxPlayers);
	 { First record # displayed will be 1 }
END;     { GetRecordNum ---------------------------------------------- }


PROCEDURE ShowMenu;       {VERIFIED 02/10/06}
BEGIN
  ClrScr;

  CWritelnC('`%** `@The Village Hut `0Player Database Editor `$'+Version+' `%**');  {Line 1}
    {12/01/06: added "Database" to program name.}

  CWritelnC('`%HUTPLAY.DAT Record Number: '+GetRecordNum);              {Line 2}
  CWriteLn(' ');

  { CwGotoXY, CWriteXY notes: X is position #, Y is line #. }

  CWGotoXY(3,4);   { Line 4 }
  CWriteLN('`#(`%1`#) `!Real Name     `%: '+Get(RealName));

  { -------------------------------------------- }
  CWGotoXY(3,5);                {Line 5}
  CWrite('`#(`%2`#) `!LORD Name     `%: '+Get(LordName));

  CWGotoXY(45,5);
  CWriteLN('`#(`%3`#) `!Player #`%: '+Get(PlayNum));
  { -------------------------------------------- }

  CWGotoXY(3,6);                 {Line 6}
  CWrite('`#(`%4`#) `!Visits Today  `%: '+Get(Visits));

  CWGotoXY(38,6);
  CWriteLN('`#(`%5`#) `!Hit-Points     `%: '+Get(HitPts));
  { -------------------------------------------- }

  CWGotoXY(3,7);                 {Line 7}
  CWrite('`#(`%6`#) `!Max HitPoints `%: '+Get(HitMax));

  CWGotoXY(38,7);
  CWriteLN('`#(`%7`#) `!Strength Pts   `%: '+Get(Str_Pts));
  { -------------------------------------------- }

  CWGotoXY(3,8);                 {Line 8}
  CWrite('`#(`%8`#) `!Defense Pts   `%: '+Get(Defense));

  CWGotoXY(38,8);
  CWriteLN('`#(`%9`#) `!Charm Points   `%: '+Get(CharmPts));
  { -------------------------------------------- }

  CWGotoXY(3,9);                 {Line 9}
  CWrite('`#(`%0`#) `!Forest Fights `%: '+Get(FFights));

  CWGotoXY(38,9);
  CWriteLN('`#(`%A`#) `!Human Fights   `%: '+Get(PFights));
  { -------------------------------------------- }

  CWGotoXY(3,10);                 {Line 10}
  CWrite('`#(`%B`#) `!Gems Found    `%: '+Get(Jewels));

  CWGotoXY(38,10);
  CWriteLN('`#(`%C`#) `!Kids Adopted   `%: '+Get(Adoptions));
  { -------------------------------------------- }

  CWGotoXY(3,11);                {Line 11}
  CWriteLn('`#(`%D`#) `!Skill Points  `%: '+Get(Skill_Pts));

  CWGotoXY(38,11);
  CWriteLN('`#(`%E`#) `!# of Transfers `%: '+Get(Gold_Count));

  { 02/10/06: Deleted statements for LAYS and SKILL_USES.  Not used by IGM now. }
  { -------------------------------------------------------------------------------- }

  CWGotoXY(3,12);                 {Line 12}
  CWrite('`#(`%F`#) `!Gold Transfers Amt`%: '+Get(Gold_Trans));

  CWGotoXY(41,12);                {Added 02/17/06}
  CWriteLn('`#(`%I`#) `!Has Mine Tools?`%: '+Get(HasTools));  {added 02/17/06}
  { -------------------------------------------- }

  CWGotoXY(3,13);                 {Line 13}
  CWrite('`#(`%G`#) `!Gold Coins Found  `%: '+Get(Gold));

  CWGotoXY(41,13);                {Added 02/17/06}
  CWriteLn('`#(`%J`#) `!Mine Turns Left`%: '+Get(TurnsLeft));  {added 02/17/06}
  { -------------------------------------------- }

  CWGotoXY(3,14);                 {Line 14}
  CWrite('`#(`%H`#) `!Wisdom Points     `%: '+Get(Wisdom));
			 {08/04/07: Changed "Exp. Points Gain" to "Wisdom Points".}

  CWGotoXY(41,14);                {Added 03/02/06}
  CWriteLn('`#(`%K`#) `!Is Mine Closed?`%: '+Get(MineClosed));  {added 03/02/06}
  { -------------------------------------------- }

  CWGotoXY(3,15);                 {Line 15}
  CWriteLn('`#(`%L`#) `!Wishes Made Today `%: '+Get(Wish_Count));  {added 03/02/06}
  { -------------------------------------------- }

  CWriteLn(' ');  {Blank Line, Line #16}

  { --------------------------------------------------------------- }
  CWGotoXY(3,17);
	 CWrite('`2(`0X`2) `%Search by Name');

  CWGotoXY(40,17);
  CWriteln('`2(`0]`2) `%Advance One Record');
  { -------------------------------------------- }

  CWGotoXY(3,18);
	 CWrite('`2(`0[`2) `%Back Up One Record');

  CWGotoXY(40,18);
  CWriteln('`2(`0*`2) `%Reset Player Stats');
  { -------------------------------------------- }

  CWriteln(' ');  {Blank Line, Line #19.}

  CWGotoXY(3,19);
  Cwrite('`$    Input key to change, or `%Q `$to quit and save.');
END;     { ShowMenu  ------------------------------------------------------ }


{ X }PROCEDURE Do_PlayerSearch;    {VERIFIED 02/10/06}
VAR Counter, YN : BYTE;
	 Temp, OTemp : STRING;

BEGIN
  Editor_FN:= IGMDir+HutPlayer_FN;  {VERIFIED Editor_FN content. 02/10/06}

  IF NOT Exist(Editor_FN) THEN Exit;
	  { if no HUTPLAY.DAT then we can't search and
		 couldn't have made it here to begin with. }

  Counter:= 0;
  Temp:= PromptStr(0,0,50,' Enter full or partial name:',' Player Search ','',FALSE);
  OTemp:= Temp;
  Temp:= S2U(Temp);  { upcase the whole string }

  REPEAT
	 Search(Counter);

	 { This next evaluation is checking to see if TEMP exists anywhere in
		either field of record.  If YES, then execute the next section,
		otherwise increment counter and move on.  Note: Using FUNCTION NoColor
		to strip Lord color codes for string eval and display. }

	 IF (POS(Temp,S2U(TSearch.LordName))>0) OR (POS(Temp,NoColor(S2U(TSearch.RealName)))>0) THEN
		BEGIN
		  YN:= PromptYesNo('','Are you looking for:|'+TSearch.LordName+' known as '+NoColor(TSearch.RealName)+'?');
		  IF YN=1 THEN {1 means YES answer}
			 BEGIN
				RecordNum:= Counter; { LORD Player # to display matches the counter }

				READ_VISITORS_FILE;
				ShowMenu;
				Exit; { bail out of loop since we got who we want }
			 END;
		END;
	 Inc(Counter);
  UNTIL Counter=MaxPlayers; { End of repeat loop, repeats until we get
										to last player record. }

  { if we make it to here, then there were no matches. }

  PromptOK(' Search Error! ','No match found for '+OTemp+'!');  {02/11/04}
END;   { Do_PlayerSearch ====================================== }


{ #### 02:51 am: Stopped conversion process to change    #### }
{ Jackedit.pas program code into Hut2edit.pas code.  02/09/06 }


PROCEDURE RunEditor;      {VERIFIED 02/10/06}
  VAR Ch:CHAR;
BEGIN
  ShowMenu;

  REPEAT
    Ch:= AInput('1234567890ABCDEFGHIJKLQX][*');   {02/17/06: Added I and J.}
                    {03/02/06: Added K and L options}
    CASE Ch OF
      '1' : Do_RealName;         {VERIFIED 02/10/06}

      '2' : Do_LordName;        {VERIFIED 02/10/06}

		'3' : BEGIN               {Edited 07/22/07: verified 07/22/07}
              CWGotoXY(1,25);

              CWriteLn('  `0The `$LORD Player Number `0field is display-only.  I don''t see ');
              CWriteLn('  `0a valid reason to allow it to be edited.  3-second delay. ');
              DELAY(3000);

				  IF DebugVar THEN   {Added 07/22/07: verified 07/22/07}
                BEGIN
                  BLANK(1);
                  CWriteLn('  `0Usage of `!/DEBUG `0parameter was detected, so user is ');
                  CWriteLn('  `0allowed to modify the Player Number field.  Do so with ');
                  CWriteLn('  `@CAUTION `0because it is a `@VERY `0important database field.');
                  DELAY(3000);

                  DO_PLAYER_NUMBER;
                END;

              ShowMenu;
            END;

      '4' : Do_Visits;         {VERIFIED 02/10/06}

      '5' : Do_HitPoints;    {VERIFIED 02/10/06}

      '6' : Do_HitMax;      {VERIFIED 02/10/06}

      { 02/10/06: Deleted statements for LAYS and SKILL_USES.  Not used by IGM now. }

      '7' : Do_Strength;      {VERIFIED 02/10/06}

      '8' : Do_Defense;       {VERIFIED 02/10/06}

      '9' : Do_Charm;          {VERIFIED 02/10/06}

      '0' : Do_Forest;        {VERIFIED 02/10/06}

      'A' : Do_Human;       {VERIFIED 02/10/06}

      'B' : Do_Gems;          {VERIFIED 02/10/06}

      'C' : DO_Adoptions;     {VERIFIED 02/10/06}

      'D' : DO_Skill_Points;   {VERIFIED 02/10/06}

      'E' : Do_Gold_Count;      {VERIFIED 02/10/06}

      'F' : Do_Gold_Transfers;  {VERIFIED 02/10/06}

      'G' : DO_GOLD_COINS;      {VERIFIED 02/10/06}

      'H' : Do_Wisdom;          {VERIFIED 02/10/06}

      'I' : Do_Has_Tools;       {Added 02/17/06: Verified 02/17/06}

      'J' : Do_Turns_Left;      {Added 02/17/06: Verified 02/17/06}

      'K' : Do_Mine_Closed;       {Added 03/02/06: verified}

      'L' : Do_Wishes;            {Added 03/02/06: verified}

      { ------------------------------------------------------ }
      { Q - reserved for QUIT/SAVE Changes command processing. }
      { ------------------------------------------------------ }

      'X' : Do_PlayerSearch;       {VERIFIED 02/10/06}

      ']' : BEGIN                  {VERIFIED 02/10/06}
              Inc(RecordNum);
              IF RecordNum > (MaxPlayers - 1) THEN RecordNum:= 0;

              READ_VISITORS_FILE;
              ShowMenu;
            END;

      '[' : BEGIN                        {VERIFIED 02/10/06}
              IF RecordNum=0 THEN RecordNum:= (MaxPlayers - 1)
                ELSE Dec(RecordNum);

              READ_VISITORS_FILE;
              ShowMenu;
            END;

      '*' : BEGIN                  {re-VERIFIED 05/28/07}
              Do_NewDay;

              ShowMenu;

              WRITE_VISITORS_FILE;
            END;
    END;       {CASE CH - ending}

  UNTIL Ch = 'Q';
END;       { RunEditor ---------------------------------------------------------- }


PROCEDURE EXIT_SCREEN;     {VERIFIED 02/10/06}
BEGIN
  { the | character will cause a linefeed, I forget what max chars }
  { are.  Anyhow, say whatever you want here or remove it totally }

         {12/01/06: added "Database" to program name.}
  PromptOK(' The Village Hut''s Player Database Editor Credits: ',
			'HUT2EDIT.EXE '+Version+'.  Copyright 2006-2007 by Donald Tidmore. |'

			+'** Dedicated to Ken Davis and Seth Able Robinson. ** ||'

			(*  +'Compile Date:  '+Compile_Date+'  ** August 2007 Development. ||'  *)
				{06/04/07: Added ending period to Compile_Date const.}

			+'Released v1.00 officially on:  '+Release_Date+' ||'
						  {Enabled 08/12/07}

			+'Utility Path: '+Editor_FN);  {revised 08/12/07}
END; { EXIT_SCREEN ============================================ }


BEGIN    { Main HUT2EDIT.pas BEGIN/END structure }
  ClrScr;

  CursorOff;                  {Gold Tool-Kit process}
  UseLordColors:= TRUE;

  DebugVar:= FALSE;   {Added 07/22/07}

  IF S2U(ParamStr(1)) = '/DEBUG'  {Added 07/22/07}
	 THEN DebugVar:= True;

  ReadVars.ReadHelp:= NIL;  { removes the HELP button in the prompts. }   {Gold Tool-Kit process}

  WinNoClose:= TRUE;        { removes the prompt window close
									  button in upper left. }      {Gold toolkit process}

  RecordNum:= 0;

  IF Exist('HutPlay.dax') THEN DeleteFile('HutPlay.dax');

  READ_CONFIG;  {process existing HUT2EDIT.cfg file.}
		{12/01/06: renamed ReadConfig to Read_Config.}

  Editor_FN:= IGMDir+HutPlayer_FN;
	 {Global change 08/12/07: Replaced Utility_Path with Editor_FN.}

  IF Exist(Editor_FN) THEN READ_VISITORS_FILE  {VERIFIED}
  ELSE
	 BEGIN                                      {VERIFIED}
		CWriteLn(' ');
		CWriteLn('  `@ERROR:  `0HUT2EDIT `!could not locate `@The Village Hut''s ');
		CWriteLn('  `!HUTPLAY.DAT file, which is `%REQUIRED `!for you to edit ');
		CWriteLn('  `!the IGM''s database records.');

		CWriteLn(' ');
		CWriteLn('  `0HUT2EDIT `!looked for this file, which was not found: ');
		CWriteLn('    `$'+Editor_FN);

		CWriteLn(' ');
		CWriteLn('  `!Terminating `0HUT2EDIT `!immediately.  ');

      HALT;
    END;
  { =========================================================== }

  RunEditor;

  EXIT_SCREEN;

  ResetStartUpMode;     {Gold toolkit process}
END. { HUT2EDIT.pas }

        { 02/10/06: All primary code, menu data layout verified 03:50 am }
        { 02/10/06: Changed from 0.25 to v0.50 beta.  2nd day's work.    }
        { 02/17/06: v0.60 beta - Added Has_Tools and Turns_Left vars support. }
        { 03/02/06: v0.65 beta used. 04/04: v0.70 beta used. }
        { 05/01/06: version # changed to v0.75. 06/25/06: v0.80. cursor bug fix. }
        { 06/29/06: Fixed some data range values that were incorrect. }

   {12/01/06: added "Database" to program name.}

    { Started creation using JackEdit source code 02/09/2006. }
         { 10/01/06: Changed to v0.85 beta. }
         { 02/04/07: changed to v0.90 Beta. }
         { 05/28/07: Changed to v0.95 beta. }
         {1st compile done 04:05 am 02/09/06}

